export { AllSymbol } from "./model_definitions.js";
import { MongoClient } from "mongodb";
import Model from "./model.js";
export default class SafeMongo {
    database_name;
    client;
    db;
    waiting = [];
    constructor(uri, database_name, options) {
        this.database_name = database_name;
        options = {
            ...options,
        };
        this.client = new MongoClient(uri, options);
    }
    addModel(definition) {
        return new Model(this, definition);
    }
    async awaitConnected() {
        if (this.db)
            return;
        return new Promise((yes) => this.waiting.push(() => yes()));
    }
    connect() {
        return this.client
            .connect()
            .then(() => (this.db = this.client.db(this.database_name)))
            .then(() => {
            this.waiting.forEach((e) => e());
        });
    }
    disconnect() {
        return this.client.close();
    }
    getClient() {
        return this.client;
    }
}
//# sourceMappingURL=index.js.map